/*
  Mete Hoca LogicShield Rev.1 | Arduino Uno için Lojik Kapı Simülasyon Shield'i
 
  LogicShield, öğrencilerin lojik kapı adı verilen elektronik yapıları öğrenmeleri
  için geliştirilmiştir. Arduino Uno üzerine takılan bir shield olarak tasarlanan LogicShield,
  öğrencilerin 8 temel lojik kapıyı etkileşimli olarak deneyimlemelerini sağlar.
  
  LogicShield'ın detaylı açıklamasını web sitemizde bulabilirsiniz.
 
  Mete Hoca
  https://www.metehoca.com/
*/

int AND_IN1 = A2;
int AND_IN2 = A3;
int AND_OUT = A1;

int OR_IN1 = A4;
int OR_IN2 = A5;
int OR_OUT = A0;

int NAND_IN1 = 11;
int NAND_IN2 = 9;
int NAND_OUT = 10;

int NOR_IN1 = 8;
int NOR_IN2 = 7;
int NOR_OUT = 1;

int XOR_IN1 = 4;
int XOR_IN2 = 2;
int XOR_OUT = 3;

int XNOR_IN1 = 6;
int XNOR_IN2 = 5;
int XNOR_OUT = 0;

int NOT_IN = 13;
int NOT_OUT = 12;

void setup() {
  pinMode(AND_IN1, INPUT);
  pinMode(AND_IN2, INPUT);
  pinMode(AND_OUT, OUTPUT);

  pinMode(OR_IN1, INPUT);
  pinMode(OR_IN2, INPUT);
  pinMode(OR_OUT, OUTPUT);

  pinMode(NAND_IN1, INPUT);
  pinMode(NAND_IN2, INPUT);
  pinMode(NAND_OUT, OUTPUT);

  pinMode(NOR_IN1, INPUT);
  pinMode(NOR_IN2, INPUT);
  pinMode(NOR_OUT, OUTPUT);

  pinMode(XOR_IN1, INPUT);
  pinMode(XOR_IN2, INPUT);
  pinMode(XOR_OUT, OUTPUT);

  pinMode(XNOR_IN1, INPUT);
  pinMode(XNOR_IN2, INPUT);
  pinMode(XNOR_OUT, OUTPUT);

  pinMode(NOT_IN, INPUT);
  pinMode(NOT_OUT, OUTPUT);
}

void loop() {
  digitalWrite(AND_OUT, (digitalRead(AND_IN1) & digitalRead(AND_IN2)));
  digitalWrite(OR_OUT, (digitalRead(OR_IN1) | digitalRead(OR_IN2)));
  digitalWrite(NAND_OUT, !(digitalRead(NAND_IN1) & digitalRead(NAND_IN2)));
  digitalWrite(NOR_OUT, !(digitalRead(NOR_IN1) | digitalRead(NOR_IN2)));
  digitalWrite(XOR_OUT, (digitalRead(XOR_IN1) ^ digitalRead(XOR_IN2)));
  digitalWrite(XNOR_OUT, !(digitalRead(XNOR_IN1) ^ digitalRead(XNOR_IN2)));
  digitalWrite(NOT_OUT, !(digitalRead(NOT_IN)));
}
